## Dataclass (array of records) file handing tasks.

## The code below is a generic file handling function that uses a dataclass object to store the file data.
## For each of the tasks below you will have to open and examine the data in the csv file and then:
##   - create an appropriate list in the main program to store the dataclass objects and pass it in as a parameter
##   - connect to the correct file
##   - use the elements of the split row to create a new dataclass object (ensuring you use int() and float() where numerical data is being stored)
##   - return the correct list

## You may write all the code for the two tasks in here but you may find it easier to create a separate program for each task.
## Each task will have a straightforward standard algorithm and then others with a twist.

## TASK 1
## Using the file "census2010.csv" (state,percentage unemployed,population) create procedures or functions to:
## - Display the smallest population
## - Display the name of the state with the highest unemployment
## - Ask the user to enter the name of a state and display the size of the population of that state
## - For all states with over 10% unemployment, display the name of the state and the number of people unemployed

## TASK 2(Challenging Ones)
## Using the file "titanic.csv" (passenger class,survived(o = died, 1 = survived),name,age (age unknown = 999) create procedures or functions to:
## - Display the number of passengers who had not provided their age before travelling.
## - Display how many first class passengers (passenger class 1) survived and how many died when the titanic sank.
## - Display the same as above for third class passengers
## - For only the passengers whose age was known, display the average age of the passengers who died.
## - Ask the user to enter a letter and display the names of the passengers who survived, whose surnames started with that letter.



from dataclasses import dataclass

# Using dataclass to simulate a record-like structure
# This creates a simplfied version of a class object 

@dataclass
class ????????:       # Change the question marks to an appropriate class name (remember it must state with a capital letter).
    field1: str       # Change to appropriate field names and data types, for example - forename: str
    field1: float
    field1: int



def readFile(allObjects):              # pass in a single list to store the dataclass objects
    eachRow = []

    with open(".csv",'r') as everything:            # connect to the file as read only

        for each in everything.readlines():         # loop for each line of the file

            row = each[0:-1]                        # remove the end of line character \n from the file line
            eachRow = row.split(",")                # create a temporary list from each part of the file line
                                                    
            tempObject = ????????(eachRow[0],eachRow[1],eachRow[2])  # create a new dataclass object using the elements of the eachrom list as the attributes
                                                                     # you will have to change the question marks again to match your chosen class name above
                                                                     # change each of the attributes to the correct data type, for example int(eachRow[1]) if the second column in the file contains integers

            allObjects.append(tempObject)           # add the new object to the list of objects
        

    return allObjects         # return the populated list of objects

## Add additional procedures and functions here






## MAIN PROGRAM
allObjects = []

## Call procedures and functions from here.

allObjects = readFile(allObjects)


